*
*		GIFld.s	
*			1999/05/09 Rick
*
*	based on giftoppm.c (netpbm)

* +-------------------------------------------------------------------+ */
* | Copyright 1990, 1991, 1993, David Koblas.  (koblas@netcom.com)    | */
* |   Permission to use, copy, modify, and distribute this software   | */
* |   and its documentation for any purpose and without fee is hereby | */
* |   granted, provided that the above copyright notice appear in all | */
* |   copies and that both that copyright notice and this permission  | */
* |   notice appear in supporting documentation.  This software is    | */
* |   provided "as is" without express or implied warranty.           | */
* +-------------------------------------------------------------------+ */


RUNS_HUMAN_VERSION	equ	3
	.include	doscall.mac

	.offset 0
FN:		.ds.l	1	*0
FILEBUF:	.ds.l	1	*4
FILEBUFSIZE:	.ds.l	1	*8
CURRENTBYTE:	.ds.l	1	*12
REALWIDTH:	.ds.l	1	*16
WIDTH:		.ds.l	1	*20
HEIGHT:		.ds.l	1	*24
GETPOINT:	.ds.l	1	*28
ZERODATABLOCK:	.ds.l	1	*32
COLOR:		.ds.w	1	*36
CHAINBUF:	.ds.l	1	*38
CHAINBUFSIZE:	.ds.l	1	*42
READBUF:	.ds.l	1	*46
DICTOP:		.ds.l	1	*50
STACKTOP:	.ds.l	1	*54
BYTECOUNT:	.ds.l	1	*58
STACKPOINTER:	.ds.l	1	*62
BITPIXEL:	.ds.l	1	*66
COLORRESOLUTION:	.ds.l	1	*70
BACKGROUND:	.ds.l	1	*74
ASPECTRATIO:	.ds.l	1	*78
GRAYSCALE:	.ds.l	1	*82
TRANSPARENT:	.ds.l	1	*86
DELAYTIME:	.ds.l	1	*90
INPUTFLAG:	.ds.l	1	*94
DISPOSAL:	.ds.l	1	*98
CLEARCODE:	.ds.w	1	*102
ENDCODE:	.ds.w	1	*104
FIRSTCODE:	.ds.w	1	*106
OLDCODE:	.ds.w	1	*108
CODESIZE:	.ds.w	1	*110
CODEMASK:	.ds.w	1	*112
MAXCODE:	.ds.w	1	*114
MAXCODESIZE:	.ds.w	1	*116
SETCODESIZE:	.ds.w	1	*118
DONE:		.ds.w	1	*120
CURBIT:		.ds.w	1	*122
LASTBIT:	.ds.w	1	*124
V:		.ds.w	1	*126
IMAGELINETOP:	.ds.l	1	*128
YPOS:		.ds.w	1	*132
ADDY:		.ds.w	1	*134
ADDADD:		.ds.l	1	*136
LEN:		.ds.w	1	*140
REALHEIGHT:	.ds.w	1	*142
PASS:		.ds.w	1	*144
ADRS:		.ds.l	1	*146
FREESPACE:	.ds.w	86	*150
COLORMAP:	.ds.w	256	*322
LOCALCOLORMAP:	.ds.w	256	*834
CURRENTCOLOR:	.ds.w	1	*1346

	.even
	.text

	.globl _loadGIFfile
_loadGIFfile:
	link	a6,#-14
	movem.l	d3/a5,-(sp)
	movea.l	8(a6),a5	*psi
	move.l	#7912,FILEBUFSIZE(a5)
	pea	28672.l
	DOS	__MALLOC
	move.l	d0,FILEBUF(a5)
	addq.w	#4,sp
	tst.l	d0
	bpl	memoryok
?200:
	moveq.l	#102,d0
	add.w	d0,d0
	bra	?1
?15:
	move.l	#203,d0
	bra	?1
memoryok:
	move.l	d0,a1
	lea.l	280(a1),a0
	move.l	a0,READBUF(a5)
	lea.l	8192(a1),a0
	move.l	a0,DICTOP(a5)
	lea.l	28672(a1),a0
	move.l	a0,STACKTOP(a5)
	moveq.l	#0,d2
	move.l	d2,BYTECOUNT(a5)
	move.l	d2,ZERODATABLOCK(a5)
	moveq.l	#6,d2
	lea.l	-10(a6),a1
	bsr	ReadOK
	tst.l	d0
	beq	?15
	move.l	-10(a6),d0
	clr.b	d0
	cmp.l	#$47494600,d0	*'GIF'
	bne	notgif
	move.l	-8(a6),d0
	lsl.l	#8,d0
	cmp.l	#$38376100,d0	*'87a'
	beq	?6
	cmp.l	#$38396100,d0	*'89a'
	beq	?6
notgif:
	moveq.l	#101,d0
	add.w	d0,d0
	bra	?1
?6:
	moveq.l	#7,d2
	lea.l	-10(a6),a1
	bsr	ReadOK
	tst.l	d0
	beq	?15
	moveq.l	#0,d0
	move.b	-6(a6),d0
	moveq.l	#7,d1
	and.b	d0,d1
	moveq.l	#2,d2
	asl.l	d1,d2
	lea.l	BITPIXEL(a5),a1
	move.l	d2,(a1)
	and.b	#128,d0
	cmp.b	#128,d0
	bne	?8
	lea.l	COLORMAP(a5),a2
	move.l	(a1),d0
	bsr	ReadColorMap
	tst.l	d0
	beq	?15
?8:
	bsr	nextGIF
	cmp.l	#200,d0
	bne	?1
	moveq.l	#8,d3
	moveq.l	#16,d0
	cmp.l	BITPIXEL(a5),d0
	bcs	gifreadok
	moveq.l	#4,d3
gifreadok:
	move.w	d3,COLOR(a5)
	moveq.l	#100,d0
	add.w	d0,d0
?1:
	cmp.l	#200,d0
	beq	loadgifend
	move.l	d0,d3
	move.l	a5,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
loadgifend:
	movem.l	-22(a6),d3/a5
	unlk	a6
	rts
	.even

nextGIF:
	link	a6,#-12
	movem.l	d3/d4/a3,-(sp)
	lea.l	COLORMAP(a5),a0
	move.l	a0,d4
	lea.l	-11(a6),a3
	movea.l	a3,a1
?17:
	moveq.l	#1,d2
	bsr	ReadOK
	tst.l	d0
	beq	eread
	movea.l	a3,a1
	cmp.b	#59,(a1)
	bne	notgifterminate
	move.l	#201,d0
	bra	end_nextGIF
notgifterminate:
	cmp.b	#33,(a1)
	bne	notextention
	moveq.l	#1,d2
	bsr	ReadOK
	tst.l	d0
	beq	eread

DoExtension:
	lea	FILEBUF(a5),a2
	move.l	(a2),-(sp)
	cmp.b	#249,(a3)
	bne	?46
	bsr	GetDataBlock
	tst.l	d0
	bmi	DoExt_eread
?59:
	move.l	(a2),(sp)
?46:
	bsr	GetDataBlock
	tst.w	d0
	bmi	DoExt_eread
	bne	?59
	addq.w	#4,sp
	movea.l	a3,a1
	bra	?17
DoExt_eread:
	addq.w	#4,sp
	bra	eread

notextention:
	cmp.b	#',',(a1)
	bne	?17
	moveq.l	#9,d2
	lea.l	-10(a6),a1
	bsr	ReadOK
	tst.l	d0
	beq	eread
	move.b	-2(a6),d0
	move.b	d0,d1
	and.b	#128,d1
	cmp.b	#128,d1
	sne	d2
	moveq.l	#7,d1
	and.b	d0,d1
	addq.w	#1,d1
	moveq.l	#1,d0
	asl.l	d1,d0
	btst	#0,d2
	bne	?26
	movea.l	d4,a2		*local color map
	bsr	ReadColorMap
	tst.l	d0
	beq	eread
?26:
	move.b	-2(a6),d0
	and.b	#64,d0
	cmp.b	#64,d0
	seq	d0
	moveq.l	#1,d1
	and.b	d0,d1
	move.l	d1,-(sp)
	move.l	d4,-(sp)
?32:
	moveq.l	#0,d0
	move.w	-4(a6),d0
	ror.w	#8,d0
	move.l	d0,-(sp)
	move.w	-6(a6),d0
	ror.w	#8,d0
	move.l	d0,-(sp)
	bsr	ReadImage
	tst.l	d0
	bne	normal
eread:
	move.l	#203,d0
	bra	end_nextGIF
normal:
	moveq.l	#100,d0
	add.w	d0,d0
end_nextGIF:
	movem.l	-24(a6),d3/d4/a3
	unlk	a6
	rts
	.even

ReadColorMap:
	link	a6,#-4
	movem.l	d3/a3/a4,-(sp)
	move.l	d0,d3		*BitPixel
	lea.l	_Palette,a4
	lea.l	-4(a6),a3
	bra	readcolor_ent

readcolor_lp:
	moveq.l	#3,d2
	movea.l	a3,a1
	bsr	ReadOK
	tst.l	d0
	beq	readcolor_break

	move.b	1(a3),d0	*G
	move.b	d0,(a2)+
	lsl.w	#5,d0
	move.b	(a3),d0		*R
	move.b	d0,(a2)+
	lsr.w	#3,d0
	lsl.w	#5,d0
	move.b	2(a3),d1	*B
	move.b	d1,(a2)+
	lsr.b	#3,d1
	or.b	d1,d0
*	add.w	d0,d0
	move.w	d0,(a4)+	*ColorPalet
readcolor_ent:
	dbra	d3,readcolor_lp

	moveq.l	#1,d0
readcolor_break:
	movem.l	(sp)+,d3/a3/a4
	unlk	a6
	rts
	.even

ReadOK:
	move.l	BYTECOUNT(a5),d1
	move.l	CURRENTBYTE(a5),a0
	bra	?69
?73:
	subq.l	#1,d1		*bytecount
	bpl	?71
	move.l	FILEBUFSIZE(a5),-(sp)
	move.l	READBUF(a5),-(sp)
	move.w	FN+2(a5),-(sp)
	DOS	__READ
	move.l	d0,d1		*bytecount
	lea	10(sp),sp
	bne	?72
	moveq.l	#0,d0
	bra	?68
?72:
	move.l	READBUF(a5),a0	*currentbyte= readbuf
	subq.l	#1,d1
?71:
	move.b	(a0)+,(a1)+
?69:
	dbra	d2,?73
	moveq.l	#1,d0
?68:
	move.l	d1,BYTECOUNT(a5)
	move.l	a0,CURRENTBYTE(a5)
	rts
	.even

ReadImage:
	tst.l	BYTECOUNT(a5)
	bne	?147
	move.l	FILEBUFSIZE(a5),-(sp)
	move.l	READBUF(a5),-(sp)
	move.w	FN+2(a5),-(sp)
	DOS	__READ
	move.l	d0,BYTECOUNT(a5)
	lea	10(sp),sp
	beq	?153
	move.l	READBUF(a5),CURRENTBYTE(a5)
?147:
	move.l	CURRENTBYTE(a5),a0
	moveq.l	#0,d0
	move.b	(a0),d0		*count
	addq.l	#1,CURRENTBYTE(a5)
	subq.l	#1,BYTECOUNT(a5)
	movem.l	d3/d5/d6/d7/a6,-(sp)
	lea	SETCODESIZE(a5),a0
	move.w	d0,(a0)
	addq.w	#1,d0
	move.w	d0,CODESIZE(a5)
	moveq.l	#1,d1
	lsl.w	d0,d1
	subq.w	#1,d1
	move.w	d1,CODEMASK(a5)
	lea	CLEARCODE(a5),a1
	move.w	(a0),d1
	moveq.l	#1,d0
	lsl.w	d1,d0
	add.w	d0,d0
	add.w	d0,d0
	move.w	d0,(a1)		*clear_code
	move.w	d0,d1
	addq.w	#4,d1
	move.w	d1,ENDCODE(a5)
	addq.w	#4,d1
	move.w	d1,MAXCODE(a5)
	add.w	d0,d0
	move.w	d0,MAXCODESIZE(a5)
	moveq.l	#0,d1
	move.w	d1,d5		*curbit
	move.w	d1,d6		*lastbit
	move.w	d1,DONE(a5)
	move.l	CURRENTBYTE(a5),a6	*getpoint= currentbyte
	move.w	CLEARCODE(a5),d2
	asr.w	#2,d2
	subq.w	#1,d2
	movea.l	DICTOP(a5),a0
dicinitlp1:
	move.l	d1,(a0)+
	addq.w	#1,d1
	dbra	d2,dicinitlp1

	moveq.l	#0,d0
	move.w	#4095,d2
	bra	dicinitent2
dicinitlp2:
	move.l	d0,(a0)+
	addq.w	#1,d1
dicinitent2:
	cmp.w	d2,d1
	ble	dicinitlp2

	move.l	BYTECOUNT(a5),d7
firstcodelp:
	bsr	GetCode
	cmp.w	CLEARCODE(a5),d1
	beq	firstcodelp
	move.l	a6,GETPOINT(a5)
	move.w	d1,d0
	move.w	d5,CURBIT(a5)
	move.w	d6,LASTBIT(a5)
	move.w	d0,OLDCODE(a5)
	move.l	d7,BYTECOUNT(a5)
	asr.w	#2,d0
	move.w	d0,FIRSTCODE(a5)
	move.w	d0,V(a5)
	movem.l	(sp)+,d3/d5/d6/d7/a6

	tst.w	d0
	bge	?150
?153:
	moveq.l	#0,d0
	rts
?150:
	moveq.l	#0,d0
	move.w	6(sp),d0	*len
	move.l	d0,WIDTH(a5)
	move.w	10(sp),d0	*height
	move.l	d0,HEIGHT(a5)
	moveq.l	#3,d0
	tst.l	16(sp)		*interlace
	bne	?152
	moveq.l	#-1,d0
?152:
	move.w	d0,PASS(a5)
	clr.w	YPOS(a5)
	move.w	#8,ADDY(a5)
	move.l	WIDTH(a5),d1
	move.l	d1,d0
	lsl.l	#3,d1
	sub.l	d0,d1
	move.l	d1,ADDADD(a5)
	moveq.l	#1,d0
	rts
	.even

GetDataBlock:
	movea.l	4(sp),a1	*buf
	movea.l	CURRENTBYTE(a5),a0
	move.l	BYTECOUNT(a5),d2
	bne	countreadable
	movea.l	READBUF(a5),a0	*currentbyte = readbuf
	move.l	FILEBUFSIZE(a5),-(sp)
	move.l	(a0),-(sp)	*readbuf
	move.w	FN+2(a5),-(sp)
	DOS	__READ
	lea	10(sp),sp
	move.l	d0,d2		*bytecount
	beq	cantfilbuf
countreadable:
	moveq.l	#0,d1
	move.l	d1,d0
	move.b	(a0)+,d1
	seq	d0
	and.b	#1,d0
	move.l	d0,ZERODATABLOCK(a5)
	move.w	d1,d0
	swap.w	d1
	move.w	d0,d1
	bra	rdwtent
rdwtlp:
	subq.l	#1,d2
	bne	datareadable
	movea.l	READBUF(a5),a0
	move.l	FILEBUFSIZE(a5),-(sp)
	move.l	a0,-(sp)
	move.w	FN+2(a5),-(sp)
	DOS	__READ
	lea	10(sp),sp
	move.l	d0,d2
	subq.l	#1,d2
	bge	datareadable
cantfilbuf:
	moveq.l	#-1,d0
	bra	getdbreturn
datareadable:
	move.b (a0)+,(a1)+
rdwtent:
	dbra	d1,rdwtlp
	swap.w	d1
	move.w	d1,d0
	ext.l	d0
getdbreturn:
	move.l	a0,CURRENTBYTE(a5)
	move.l	d2,BYTECOUNT(a5)
	rts
	.even

GetCode:
	move.w	CODESIZE(a5),d2
	cmp.w	d2,d6
	bhi	?91
	tst.w	DONE(a5)
	beq	?92
	add.w	d2,d6
	ble	?93
	moveq.l	#-1,d1
	rts
?93:
	moveq.l	#-1,d1
	move.l	d1,ZERODATABLOCK(a5)
	rts
?92:
	tst.w	d7
	bne	?94
	movea.l	READBUF(a5),a1
	subq.w	#2,a1
	move.l	FILEBUFSIZE(a5),d0
	lea.l	(a1,d0.l),a0
	move.b	(a0)+,(a1)+
	move.b	(a0),(a1)+
	move.l	d0,-(sp)
	move.l	a1,-(sp)
	move.w	FN+2(a5),-(sp)
	DOS	__READ
	lea	10(sp),sp
	move.l	d0,d7
	ble	?93
	move.l	a1,CURRENTBYTE(a5)
?94:
	lea.l	CURRENTBYTE(a5),a1
	movea.l	(a1),a0
	subq.w	#1,d7		*bytecount--
	moveq.l	#0,d1
	move.l	d1,d0
	move.b	(a0)+,d1
	seq	d0
	move.l	a0,(a1)
	addq.b	#1,d0
	move.l	d0,ZERODATABLOCK(a5)
	beq	?95
	cmp.w	d7,d1		*bytecount
	ble	?100
	move.l	FILEBUFSIZE(a5),d0
	movea.l	READBUF(a5),a0
	lea.l	(a0,d0.l),a1
	move.w	d7,d0
	addq.w	#3,d0
	bra	?97
?99:
	move.b	-(a1),-(a0)
?97:
	dbra	d0,?99

	addq.w	#3,a0
	move.l	a0,CURRENTBYTE(a5)
	move.l	FILEBUFSIZE(a5),-(sp)
	move.l	READBUF(a5),-(sp)
	move.w	FN+2(a5),-(sp)
	DOS	__READ
	lea	10(sp),sp
	tst.l	d0
	ble	?93
	add.w	d0,d7		*bytecount
	bra	?100
?95:
	move.w	#1,DONE(a5)
?100:
	lea.l	CURRENTBYTE(a5),a1
	movea.l	(a1),a6		*getpoint
	subq.w	#2,a6
	move.b	(a6),1(a6)
	move.b	-1(a6),(a6)
	moveq.l	#16,d5
	sub.w	d6,d5		*curbit
	add.l	d1,(a1)		*currentbyte += count
	sub.w	d1,d7		*bytecount -= count
	lsl.w	#3,d1
	add.w	d1,d6		*lastbit += count * 8
?91:
	move.w	d5,d1
	lsr.w	#3,d1
	lea.l	2(a6,d1.w),a0
	move.b	(a0),d1
	swap	d1
	move.b	-(a0),d1
	lsl.w	#8,d1
	move.b	-(a0),d1

	moveq.l	#7,d0
	and.w	d5,d0
	lsr.l	d0,d1
	and.w	CODEMASK(a5),d1
	add.w	d2,d5		*curbit
	sub.w	d2,d6		*lastbit
	add.w	d1,d1
	add.w	d1,d1
	rts

	.even
	.globl	_drawGIF
_drawGIF:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	movea.l	40(sp),a5	*psi
	movea.l	GETPOINT(a5),a6
	movea.l	DICTOP(a5),a4
	movea.l	STACKTOP(a5),a3
	movea.l CHAINBUF(a5),a2
	move.l	BYTECOUNT(a5),d7
	move.w	LASTBIT(a5),d6
	move.w	CURBIT(a5),d5
	move.w	CLEARCODE(a5),d4

	move.b	V+1(a5),-(a3)	*--sp= v
ylp:
	move.w	WIDTH+2(a5),d3	*h
xlp:
	move.l	STACKTOP(a5),d1
	sub.l	a3,d1		*stack length
	beq	LWZReadByte
	cmp.w	d1,d3
	bgt	allflush
	move.w	d3,d1

.ifdef	LOOP
	subq.w	#1,d1
flushlp:
	move.b	(a3)+,(a2)+
	dbra	d1,flushlp
.else
	bsr	flush
.endif
	bra	xlpend

allflush:
	sub.w	d1,d3

.ifdef	LOOP
	subq.w	#1,d1
allflushlp:
	move.b	(a3)+,(a2)+
	dbra	d1,allflushlp
.else
	bsr	flush
.endif

LWZReadByte:
	bsr	GetCode
	blt	ylpbreak
	cmp.w	d4,d1		*clear_code
	beq	dicclear

	cmp.w	ENDCODE(a5),d1	*end_code
	beq	terminate
	move.w	d1,d2		*incode
	lea.l	MAXCODE(a5),a1
	cmp.w	(a1),d1		*maxcode
	blt	back_ent
	move.b	FIRSTCODE+1(a5),-(a3)
	move.w	OLDCODE(a5),d1
	bra	back_ent
back_lp:
	move.l	(a4,d1.w),d0
	move.b	d0,-(a3)
	swap.w	d0
	cmp.w	d0,d1		*circular table entry
	beq	ylpbreak
	move.w	d0,d1
back_ent:
	cmp.w	d4,d1
	bge	back_lp

	move.w	2(a4,d1.w),d0
	move.w	d0,FIRSTCODE(a5)
	move.b	d0,-(a3)	*--sp

	move.w	(a1),d1		*maxcode
	cmp.w	#16384,d1
	bcc	xlp_ent

	lea.l	(a4,d1.w),a0
	move.w	OLDCODE(a5),(a0)+		*prefix
	move.w	d0,(a0)		*firstcode	*suffix
	addq.w	#4,d1		*++maxcode
	move.w	d1,(a1)+
	move.w	(a1),d0		*maxcodesize
	cmp.w	d1,d0
	bhi	xlp_ent

	cmp.w	#16384,d0
	bcc	xlp_ent

	add.w	d0,(a1)		*maxcodesize*= 2
	lea.l	CODESIZE(a5),a0
	addq.w	#1,(a0)+	*++codesize
	move.w	(a0),d0		*codemask
	add.w	d0,d0
	addq.w	#1,d0
	move.w	d0,(a0)
xlp_ent:
	move.w	d2,OLDCODE(a5)	*incode
	bra	xlp

dicclear:
	moveq.l	#0,d1
	movea.l	a4,a0
	move.w	d4,d2
	subq.w	#1,d2
dicclrlp1:
	move.l	d1,(a0)+
	addq.w	#1,d1
	dbra	d2,dicclrlp1

	moveq.l	#0,d0
	move.w	#4096,d2
	sub.w	d1,d2
	bra	dicclrent2
dicclrlp2:
	move.l	d0,(a0)+
dicclrent2:
	dbra	d2,dicclrlp2

	move.w	SETCODESIZE(a5),d1
	addq.w	#1,d1
	move.w	d1,CODESIZE(a5)
	moveq.l	#1,d0
	lsl.w	d1,d0
	subq.w	#1,d0
	move.w	d0,CODEMASK(a5)
	move.w	d4,d0		*clear_code
	move.w	d0,d1
	add.w	d0,d0
	move.w	d0,MAXCODESIZE(a5)
	addq.w	#8,d1
	move.w	d1,MAXCODE(a5)
	move.l	STACKTOP(a5),a3
	bsr	GetCode
	move.w	d1,OLDCODE(a5)
	lsr.w	#2,d1
	move.w	d1,FIRSTCODE(a5)
	move.b	d1,-(a3)
	bra	xlp

xlpend:
	lea.l	PASS(a5),a0
	move.w	(a0),d0		*pass
	bmi	notinterlace

	move.w	ADDY(a5),d1
	add.w	d1,YPOS(a5)
	adda.l	ADDADD(a5),a2
	move.w	HEIGHT+2(a5),d1
	cmp.w	YPOS(a5),d1
	bgt	ylp

	subq.w	#1,d0		*pass-
	move.w	d0,(a0)
	bmi	terminate	*pass0
	beq	pass1		*pass1
	subq.w	#2,d0
	bmi	pass2		*2
	bne	ylpbreak	*3<pass
pass3:
	move.l	WIDTH(a5),d0
	lsl.l	#2,d0		*width * 4
	move.w	#4,YPOS(a5)	*ypos = 4
	movea.l	CHAINBUF(a5),a2
	adda.l	d0,a2
	bra	ylp
pass1:
	move.l	WIDTH(a5),d0
	move.l	d0,ADDADD(a5)
	moveq.l	#1,d1
	bra	@f
pass2:
	move.l	WIDTH(a5),d0
	move.l	d0,d1
	add.l	d0,d0
	add.l	d0,d1
	move.l	d1,ADDADD(a5)
	moveq.l	#2,d1
@@
	move.w	d1,YPOS(a5)
	add.w	d1,d1
	move.w	d1,ADDY(a5)	*addy = 4
	movea.l	CHAINBUF(a5),a2
	adda.l	d0,a2
	bra	ylp

notinterlace:
	addq.w	#1,YPOS(a5)
	move.w	HEIGHT+2(a5),d1
	cmp.w	YPOS(a5),d1
	bgt	ylp
terminate:
	move.l	#201,d0		*PICSLICE_TERMINATE
	bra	endop
ylpbreak:
	move.l	#203,d0		*PICSLICE_EREAD
endop:
	move.l	d0,d3
	move.l	a5,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even
	.end
