*========================================================================
*	PCDsub.s
*	based on buffer.s ( pcdtoglm )
*			Written by Igarashi
*
*	v HAS060 v3.09+82 ȍ~
*========================================================================
*========================================================================
*@{t@C̒쌠͍ҁi炵jɑ܂Ap҂̏펯ƐӔC
*͈͂ɂāARɎgp /  / zt / 邱Ƃł܂B̍ہA
*߂KvȂ΁ACeB̗ނؕKv܂B
*
*@{t@C͖ۏ؂łB{t@CgpʂɂāA҂͈؂
*ӔC𕉂Ȃ̂Ƃ܂B
*========================================================================
		.cpu	68000
*------------------------------------------------------------------------
		.include	libpcd.mac
*------------------------------------------------------------------------
GET0GRB		.macro	dat1,dat2,dat34,dat5,work1,work2
				* out: work1.w
				* broken: dat1, work2
				* dest ̓CNg
		move.l	dat1,work2
		add.l	dat2,work2	* work2 = f1(Y) + f2(Cr)
		CHK256	work2
		lsr.w	#3,work2
		move.w	work2,work1	* work1 = 00000000000BBBBB

		move.l	dat1,work2
		add.l	dat34,work2	* work2 = f1(Y) + f3(Cb) + f4(Cr)
		CHK256	work2
		move.b	work2,-(sp)
		move.w	(sp)+,work2
		lsr.w	#1,work2
		andi.w	#%01111100_00000000,work2
		or.w	work2,work1	* work1 = 0GGGGG00000BBBBB

		add.l	dat5,dat1	* dat1 ( broken ) = f1(Y) + f5(Cr)
		CHK256	dat1
		add.w	dat1,dat1
		add.w	dat1,dat1
		andi.w	#%00000011_11100000,dat1
		or.w	dat1,work1	* work1 = 0GGGGGRRRRRBBBBB
		.endm

*------------------------------------------------------------------------
		.text
*------------------------------------------------------------------------
		.xdef	_pcd_to0grb
		.xref	_pcd_read_ycc
		.xref	_pcd_multbl
*========================================================================
*	int pcd_to0grb( PCDINFO *pcd, unsigned char *dest, int flag )
*========================================================================
_pcd_to0grb:
SAVREGS		.reg	a0
		.offsym	0
_regs:		.ds.b	.sizeof.(SAVREGS)
_pc:		.ds.l	1
pcd:		.ds.l	1
dest:		.ds.l	1
flag:		.ds.l	1
		.text

		tst.l	(flag-.sizeof.(SAVREGS),sp)
		bne	_pcd_000

*		movem.l	SAVREGS,-(sp)
		move.l	SAVREGS,-(sp)
		movea.l	(pcd,sp),a0
		move.w	(PCDI_ROT,a0),d0
*		movem.l	(sp)+,SAVREGS
		move.l	(sp)+,SAVREGS
		add.w	d0,d0
		move.w	(@f,pc,d0.w),d0
		jmp	(@f,pc,d0.w)

@@:		.dc.w	_pcd_000-@b
		.dc.w	_pcd_090-@b
		.dc.w	_pcd_180-@b
		.dc.w	_pcd_270-@b

*========================================================================
*
*========================================================================
_pcd_000:
SAVREGS		.reg	d1-d7/a0-a6
		.offsym	0
_pcd:		.ds.l	1	* K擪 ( for _pcd_read_ycc() )
_height:	.ds.w	1	* ( for loop )
_ybuf:		.ds.l	1
_cbbuf:		.ds.l	1
_regs:		.ds.b	.sizeof.(SAVREGS)
_pc:		.ds.l	1
pcd:		.ds.l	1
dest:		.ds.l	1
		.text

		lea.l	(-(_pc-_pcd),sp),sp
		movem.l	SAVREGS,(_regs,sp)

		movem.l	(pcd,sp),a5-a6	* a5 = pcd
					* a6 = dest

		move.l	a5,_pcd(sp)	* ( for _pcd_read_ycc() )

		clr.l	d6
		move.w	(PCDI_WIDTH,a5),d6	* d6.w = width
		move.w	(PCDI_HEIGHT,a5),(_height,sp)

		movea.l	(PCDI_YCCBUF,a5),a3	* a3 = Ybuf
		lea.l	(0,a3,d6.w),a4		* note: width <=32767 肵Ă
		adda.l	d6,a4			* a4 = Cbbuf
		movem.l	a3-a4,(_ybuf,sp)

		lsr.w	#1,d6			* d6.w = width / 2
		move.w	d6,d0
		subq.w	#1,d0
		swap.w	d6
		move.w	d0,d6
		swap.w	d6			* d6.highw = width / 2 - 1

		lea.l	(_pcd_multbl),a5	* a5 = pcd_multbl
_000_yloop:
		jbsr	_pcd_read_ycc		* broken: d0-d2/a0-a2
		tst.l	d0
		beq	_000_retn

PUT000		.macro
		move.l	d6,d7
		swap.w	d7
@xloop:
				* d6.w = width / 2
				* d7.w = width / 2 - 1 ( for dbra )
				*   a3 = Ybuf
				*   a4 = Cbbuf ( (0,a3,d6.w) = Crbuf )
				*   a5 = pcd_multbl
				*   a6 = dest
		GETTBL	a4,d6,d1,d2,d3,a5	* d1.l = f2(Cb)
						* d2.l = f3(Cb) + f4(Cr)
						* d3.l = f5(Cr)
		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,(a6)+

		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,(a6)+

		dbra	d7,@xloop
		.endm

		movem.l	(_ybuf,sp),a3-a4
		PUT000
		movea.l	(_cbbuf,sp),a4
		PUT000

		subq.w	#2,(_height,sp)	* note: height % 2 == 0 肵Ă
		bne	_000_yloop

		moveq.l	#TRUE,d0
_000_retn:
		movem.l	(_regs,sp),SAVREGS
		lea.l	(_pc-_pcd,sp),sp
		rts

*========================================================================
*
*========================================================================
_pcd_090:
SAVREGS		.reg	d1-d7/a0-a6
		.offsym	0
_pcd:		.ds.l	1	* K擪 ( for _pcd_read_ycc() )
_height:	.ds.w	1	* ( for loop )
_nextdot:	.ds.l	1	* 1 hbg` dest ɉItZbg ( keep )
_nextline:	.ds.l	1	* 1 C` dest ɉItZbg ( keep )
_ybuf:		.ds.l	1
_cbbuf:		.ds.l	1
_regs:		.ds.b	.sizeof.(SAVREGS)
_pc:		.ds.l	1
pcd:		.ds.l	1
dest:		.ds.l	1
		.text

		lea.l	(-(_pc-_pcd),sp),sp
		movem.l	SAVREGS,(_regs,sp)

		movem.l	(pcd,sp),a5-a6	* a5 = pcd
					* a6 = dest

		move.l	a5,_pcd(sp)	* ( for _pcd_read_ycc() )

		bsr	getbufsize		* d0.l = buffer size
		addq.l	#2,d0
		move.l	d0,(_nextline,sp)	* _nextline = ( buffer size ) + 2
		clr.l	d1
		move.w	(PCDI_HEIGHT,a5),d1
		move.w	d1,(_height,sp)
		add.l	d1,d1
		sub.l	d1,d0
		subq.l	#2,d0
		adda.l	d0,a6			* a6 = start dest
		neg.l	d1
		move.l	d1,(_nextdot,sp)

		clr.l	d6
		move.w	(PCDI_WIDTH,a5),d6	* d6.w = width

		movea.l	(PCDI_YCCBUF,a5),a3	* a3 = Ybuf
		lea.l	(0,a3,d6.w),a4		* note: width <=32767 肵Ă
		adda.l	d6,a4			* a4 = Cbbuf
		movem.l	a3-a4,(_ybuf,sp)

		lsr.w	#1,d6			* d6.w = width / 2
		move.w	d6,d0
		subq.w	#1,d0
		swap.w	d6
		move.w	d0,d6
		swap.w	d6			* d6.highw = width / 2 - 1

		lea.l	(_pcd_multbl),a5	* a5 = pcd_multbl
_090_yloop:
		jbsr	_pcd_read_ycc		* broken: d0-d2/a0-a2
		tst.l	d0
		beq	_090_retn

PUT090		.macro
		move.l	d6,d7
		swap.w	d7
@xloop:
				* d6.w = width / 2
				* d7.w = width / 2 - 1 ( for dbra )
				*   a3 = Ybuf
				*   a4 = Cbbuf ( (0,a3,d6.w) = Crbuf )
				*   a5 = pcd_multbl
				*   a6 = dest
		GETTBL	a4,d6,d1,d2,d3,a5	* d1.l = f2(Cb)
						* d2.l = f3(Cb) + f4(Cr)
						* d3.l = f5(Cr)
		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,(a6)
		adda.l	(_nextdot,sp),a6

		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,(a6)
		adda.l	(_nextdot,sp),a6

		dbra	d7,@xloop
		.endm

		movem.l	(_ybuf,sp),a3-a4
		PUT090
		adda.l	(_nextline,sp),a6
		movea.l	(_cbbuf,sp),a4
		PUT090
		adda.l	(_nextline,sp),a6

		subq.w	#2,(_height,sp)	* note: height % 2 == 0 肵Ă
		bne	_090_yloop

		moveq.l	#TRUE,d0
_090_retn:
		movem.l	(_regs,sp),SAVREGS
		lea.l	(_pc-_pcd,sp),sp
		rts

*========================================================================
*
*========================================================================
_pcd_180:
SAVREGS		.reg	d1-d7/a0-a6
		.offsym	0
_pcd:		.ds.l	1	* K擪 ( for _pcd_read_ycc() )
_height:	.ds.w	1	* ( for loop )
_ybuf:		.ds.l	1
_cbbuf:		.ds.l	1
_regs:		.ds.b	.sizeof.(SAVREGS)
_pc:		.ds.l	1
pcd:		.ds.l	1
dest:		.ds.l	1
		.text

		lea.l	(-(_pc-_pcd),sp),sp
		movem.l	SAVREGS,(_regs,sp)

		movem.l	(pcd,sp),a5-a6	* a5 = pcd
					* a6 = dest

		move.l	a5,_pcd(sp)	* ( for _pcd_read_ycc() )

		bsr	getbufsize		* d0.l = buffer size
		adda.l	d0,a6			* a6 = start dest ( buffer-bottom - 2 )
						* vfNĝŁAŐ

		clr.l	d6
		move.w	(PCDI_WIDTH,a5),d6	* d6.w = width
		clr.l	d0
		move.w	(PCDI_HEIGHT,a5),d0
		move.w	d0,(_height,sp)

		movea.l	(PCDI_YCCBUF,a5),a3	* a3 = Ybuf
		lea.l	(0,a3,d6.w),a4		* note: width <=32767 肵Ă
		adda.l	d6,a4			* a4 = Cbbuf
		movem.l	a3-a4,(_ybuf,sp)

		lsr.w	#1,d6			* d6.w = width / 2
		move.w	d6,d0
		subq.w	#1,d0
		swap.w	d6
		move.w	d0,d6
		swap.w	d6			* d6.highw = width / 2 - 1

		lea.l	(_pcd_multbl),a5	* a5 = pcd_multbl
_180_yloop:
		jbsr	_pcd_read_ycc		* broken: d0-d2/a0-a2
		tst.l	d0
		beq	_180_retn

PUT180		.macro
		move.l	d6,d7
		swap.w	d7
@xloop:
				* d6.w = width / 2
				* d7.w = width / 2 - 1 ( for dbra )
				*   a3 = Ybuf
				*   a4 = Cbbuf ( (0,a3,d6.w) = Crbuf )
				*   a5 = pcd_multbl
				*   a6 = dest
		GETTBL	a4,d6,d1,d2,d3,a5	* d1.l = f2(Cb)
						* d2.l = f3(Cb) + f4(Cr)
						* d3.l = f5(Cr)
		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,-(a6)

		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,-(a6)

		dbra	d7,@xloop
		.endm

		movem.l	(_ybuf,sp),a3-a4
		PUT180
		movea.l	(_cbbuf,sp),a4
		PUT180

		subq.w	#2,(_height,sp)	* note: height % 2 == 0 肵Ă
		bne	_180_yloop

		moveq.l	#TRUE,d0
_180_retn:
		movem.l	(_regs,sp),SAVREGS
		lea.l	(_pc-_pcd,sp),sp
		rts

*========================================================================
*
*========================================================================
_pcd_270:
SAVREGS		.reg	d1-d7/a0-a6
		.offsym	0
_pcd:		.ds.l	1	* K擪 ( for _pcd_read_ycc() )
_height:	.ds.w	1	* ( for loop )
_nextdot:	.ds.l	1	* 1 hbg` dest ɉItZbg ( keep )
_nextline:	.ds.l	1	* 1 C` dest ɉItZbg ( keep )
_ybuf:		.ds.l	1
_cbbuf:		.ds.l	1
_regs:		.ds.b	.sizeof.(SAVREGS)
_pc:		.ds.l	1
pcd:		.ds.l	1
dest:		.ds.l	1
		.text

		lea.l	(-(_pc-_pcd),sp),sp
		movem.l	SAVREGS,(_regs,sp)

		movem.l	(pcd,sp),a5-a6	* a5 = pcd
					* a6 = dest

		move.l	a5,_pcd(sp)	* ( for _pcd_read_ycc() )

		bsr	getbufsize		* d0.l = buffer size
		addq.l	#2,d0
		neg.l	d0
		move.l	d0,(_nextline,sp)	* _nextline = -(( buffer size ) + 2 )
		clr.l	d1
		move.w	(PCDI_HEIGHT,a5),d1
		move.w	d1,(_height,sp)
		add.l	d1,d1
		move.l	d1,(_nextdot,sp)
		subq.l	#2,d1
		adda.l	d1,a6			* a6 = start dest

		clr.l	d6
		move.w	(PCDI_WIDTH,a5),d6	* d6.w = width

		movea.l	(PCDI_YCCBUF,a5),a3	* a3 = Ybuf
		lea.l	(0,a3,d6.w),a4		* note: width <=32767 肵Ă
		adda.l	d6,a4			* a4 = Cbbuf
		movem.l	a3-a4,(_ybuf,sp)

		lsr.w	#1,d6			* d6.w = width / 2
		move.w	d6,d0
		subq.w	#1,d0
		swap.w	d6
		move.w	d0,d6
		swap.w	d6			* d6.highw = width / 2 - 1

		lea.l	(_pcd_multbl),a5	* a5 = pcd_multbl
_270_yloop:
		jbsr	_pcd_read_ycc		* broken: d0-d2/a0-a2
		tst.l	d0
		beq	_270_retn

PUT270		.macro
		move.l	d6,d7
		swap.w	d7
@xloop:
				* d6.w = width / 2
				* d7.w = width / 2 - 1 ( for dbra )
				*   a3 = Ybuf
				*   a4 = Cbbuf ( (0,a3,d6.w) = Crbuf )
				*   a5 = pcd_multbl
				*   a6 = dest
		GETTBL	a4,d6,d1,d2,d3,a5	* d1.l = f2(Cb)
						* d2.l = f3(Cb) + f4(Cr)
						* d3.l = f5(Cr)
		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,(a6)
		adda.l	(_nextdot,sp),a6

		GETTBL1	a3,d0,a5
					* d0.l = f1(Y)
		GET0GRB	d0,d1,d2,d3,d4,d5	* out: d4.w
						* broken: d0,d5
		move.w	d4,(a6)
		adda.l	(_nextdot,sp),a6

		dbra	d7,@xloop
		.endm

		movem.l	(_ybuf,sp),a3-a4
		PUT270
		adda.l	(_nextline,sp),a6
		movea.l	(_cbbuf,sp),a4
		PUT270
		adda.l	(_nextline,sp),a6

		subq.w	#2,(_height,sp)	* note: height % 2 == 0 肵Ă
		bne	_270_yloop

		moveq.l	#TRUE,d0
_270_retn:
		movem.l	(_regs,sp),SAVREGS
		lea.l	(_pc-_pcd,sp),sp
		rts

*========================================================================
*	𑜓xobt@TCY߂
*		in:	a5	PCDINFO *
*		out:	d0.l	obt@TCY
*		broken:	none
*========================================================================
getbufsize:
		move.w	(PCDI_RESO,a5),d0
		add.w	d0,d0
		add.w	d0,d0
		move.l	(@f,pc,d0.w),d0		* d0.l = buffer size
		rts
@@:
		.dc.l	192*128*2	* PCD_OVERVIEW16
		.dc.l	384*256*2	* PCD_OVERVIEW4
		.dc.l	768*512*2	* PCD_BASE
		.dc.l	1536*1024*2	* PCD_4BASE
		.dc.l	3072*2048*2	* PCD_16BASE
		.dc.l	6144*4096*2	* PCD_64BASE
*========================================================================
		.end
